<script>
  import { goto } from "$app/navigation";
  /**
   * @type {{ [x: string]: {}[]; }}
   */
  let json = {};
  /**
   * @type {any}
   */
  let text;
  /**
   * @type {HTMLButtonElement}
   */
  let button;
  /**
   * @param {{target: {files: any[];};}} e
   */
  async function uploadCSVpersonnes(e) {
    const file = e.target.files[0];
    if (file == null) return; // If user cancels file selection

    text = await file.text();
    // Convert CSV to JSON
    const lines = text.split("\n");
    const result = [];
    const headers = lines[0].split(";");
    for (let i = 1; i < lines.length; i++) {
      const obj = {};
      const currentline = lines[i].split(";");
      let count = 0;
      for (let j = 0; j < headers.length; j++) {
        // @ts-ignore
        if (currentline[j] == undefined) {
          count++;
          continue;
        }
        // @ts-ignore
        obj[headers[j].trim()] = currentline[j].trim().replace(/"/g, "");
      }
      if (count > 1) {
        break;
      }
      result.push(obj);
    }
    json["personnes"] = result;

    if (json["personnes"] && json["lots"]) {
      // Animate the button
      button.classList.add("heartbeat");
      // Change its color
      button.classList.remove("secondary");
    }
  }
  /**
   * @param {{target: {files: any[];};}} e
   */
  async function uploadCSVlots(e) {
    const file = e.target.files[0];
    if (file == null) return; // If user cancels file selection

    text = await file.text();
    // Convert CSV to JSON
    const lines = text.split("\n");
    const result = [];
    const headers = lines[0].split(",");
    for (let i = 1; i < lines.length; i++) {
      const obj = {};
      const currentline = lines[i].split(",");
      let count = 0;
      for (let j = 0; j < headers.length; j++) {
        // @ts-ignore
        if (currentline[j] == undefined) {
          count++;
          continue;
        }
        obj[headers[j].trim()] = currentline[j].trim().replace(/"/g, "");
        if (currentline[j] == "") {
          count++;
        }
      }
      if (count > 2) {
        break;
      }
      result.push(obj);
    }
    json["lots"] = result;

    if (json["lots"] != null && json["personnes"] != null) {
      // Animate the button
      button.classList.add("heartbeat");
      // Change its color
      button.classList.remove("secondary");
    }

    console.log("JSON : ", json);
  }
</script>

<svelte:head>
  <style>
    .heartbeat {
      -webkit-animation: heartbeat 1.5s ease-in-out infinite both;
      animation: heartbeat 1.5s ease-in-out infinite both;
    }
    @keyframes heartbeat {
      from {
        -webkit-transform: scale(1);
        transform: scale(1);
        -webkit-transform-origin: center center;
        transform-origin: center center;
        -webkit-animation-timing-function: ease-out;
        animation-timing-function: ease-out;
      }
      10% {
        -webkit-transform: scale(0.91);
        transform: scale(0.91);
        -webkit-animation-timing-function: ease-in;
        animation-timing-function: ease-in;
      }
      17% {
        -webkit-transform: scale(0.98);
        transform: scale(0.98);
        -webkit-animation-timing-function: ease-out;
        animation-timing-function: ease-out;
      }
      33% {
        -webkit-transform: scale(0.87);
        transform: scale(0.87);
        -webkit-animation-timing-function: ease-in;
        animation-timing-function: ease-in;
      }
      45% {
        -webkit-transform: scale(1);
        transform: scale(1);
        -webkit-animation-timing-function: ease-out;
        animation-timing-function: ease-out;
      }
    }
    @keyframes heartbeat {
      from {
        -webkit-transform: scale(1);
        transform: scale(1);
        -webkit-transform-origin: center center;
        transform-origin: center center;
        -webkit-animation-timing-function: ease-out;
        animation-timing-function: ease-out;
      }
      10% {
        -webkit-transform: scale(0.91);
        transform: scale(0.91);
        -webkit-animation-timing-function: ease-in;
        animation-timing-function: ease-in;
      }
      17% {
        -webkit-transform: scale(0.98);
        transform: scale(0.98);
        -webkit-animation-timing-function: ease-out;
        animation-timing-function: ease-out;
      }
      33% {
        -webkit-transform: scale(0.87);
        transform: scale(0.87);
        -webkit-animation-timing-function: ease-in;
        animation-timing-function: ease-in;
      }
      45% {
        -webkit-transform: scale(1);
        transform: scale(1);
        -webkit-animation-timing-function: ease-out;
        animation-timing-function: ease-out;
      }
    }
  </style>
</svelte:head>

<body class="container">
  <nav>
    <ul>
      <li><h1>TN'Event Tombola v2</h1></li>
    </ul>
  </nav>
  <main class="container">
    <label for="upload">CSV Participants :</label>
    <input
      id="upload"
      type="file"
      class="margin-left-5"
      on:change={uploadCSVpersonnes}
      accept="text/csv"
    />
    <label for="upload">CSV Lots :</label>
    <input
      id="upload"
      type="file"
      class="margin-left-5"
      on:change={uploadCSVlots}
      accept="text/csv"
    />

    <!-- spacing -->
    <br />
    <br />
    <br />

    <div class="grid">
      <div />
      <div />
      <button
        class="secondary"
        on:click={() => goto("/tirage", { state: json })}
        bind:this={button}>
          Aller au tirage
          {#if json["lots"] && json["personnes"]}
            <span class="material-icons">!!!</span>
          {/if}
        </button
      >
      <div />
      <div />
    </div>
  </main>
</body>
